/*
 * Client code generation.
 *
 * Copyright (C) 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <stdio.h>
#include "types.h"

/* Component-level processing. */

int begin_compound_output(void);
void write_compound_output(struct interface *iface);
void write_compound_dispatch_include(void);
void write_compound_interface(struct interface *iface);
void end_compound_output(void);

/* Interface processing. */

void write_files(struct interface *iface);
void write_interfaces(struct interface *iface);

/* Function details. */

void write_functions(struct signature *sig, FILE *fp, struct interface *iface,
                     void (*write_function)(struct signature *, FILE *, struct interface *));
